/* EPITA - IP - S3/4 */
/* question04 */

#define QNUM 4
#define QOPT "graine taille"
#define QNOPT 2

# include <assert.h>
# include <stdio.h>
# include <stdlib.h>
# include <unistd.h>

# include "base_test.h"
# include "question04.h"

static
void random_test(size_t len) {
  printf("Testing swap:\n");
  for (size_t i = 0; i < len; i++) {
    int a, b, old_a, old_b;
    a = random();
    b = random();
    old_a = a; old_b = b;
    printf("\tBefore swap: a = %10d | b = %10d\n", a, b);
    swap(&a, &b);
    printf("\tAfter  swap: a = %10d | b = %10d \t [%s]\n\n", a, b,
	   check(a == old_b && b == old_a));
  }
}

int main(int argc,char *argv[])
{
  size_t        size;

  help_asked(argc,argv,QNUM,QOPT,QNOPT);

  if (argc <= QNOPT)
    {
      fprintf(stderr, "Parametres insuffisants.\n");
      usage(NULL,QNUM,QOPT);
    }
  else
    {
      seedInit(argv);
      size = getSize(argv);
      random_test(size);
    }
  exit(0);
}
