/* EPITA - IP - S3/4 */
/* question07 */


# include "question07.h"

int avg(int *begin, int *end) {
  int s = 0;
  for (int *cur = begin; cur < end; cur++)
    s += *cur;
  return s / (end - begin);
}

static inline
void swap(int *a, int *b) {
  int c = *a;
  *a = *b;
  *b = c;
}

int* avg_partition(int *begin, int *end) {
  int a = avg(begin, end);
  int *pivot = begin;
  for (int *cur = begin; cur < end; cur++) {
    if (*cur <= a) {
      swap(cur, pivot);
      pivot++;
    }
  }
  return pivot;
}
