/* EPITA - IP - S3/4 */
/* question11 */

# define QNUM 11
# define QOPT "graine taille"
# define QNOPT 2

# include <unistd.h>
# include <stdlib.h>
# include <stdio.h>

# include "base_test.h"
# include "question11.h"

void test_fixed(void) {
  printf("Fixed tests:\n");
  char s[] = "abcdefghijklmnopqrstuvwxyz";
  printf("  s = \"%s\"\n", s);
  printf("  str_to_upper(s)\n");
  str_to_upper(s);
  printf("  s = \"%s\"\n", s);
}

void test_random(size_t len) {
  printf("Random tests:\n");
  char *s = calloc(len + 1, sizeof (char));
  randstr(s, len);
  s[len] = 0;
  printf("  s = \"%s\"\n", s);
  printf("  str_to_upper(s)\n");
  str_to_upper(s);
  printf("  s = \"%s\"\n", s);
  free(s);
}

int main(int argc,char *argv[]) {
  size_t                size;

  help_asked(argc,argv,QNUM,QOPT,QNOPT);

  if (argc <= QNOPT) {
    fprintf(stderr, "Parametres insuffisants.\n");
    usage(NULL,QNUM,QOPT);
  } else {
    seedInit(argv);
    size = getSize(argv);
    test_fixed();
    test_random(size);
  }
  exit(0);
}
